org.apache.xerces.impl.dtd.models

## Class DFAContentModel

- java.lang.Object
- - org.apache.xerces.impl.dtd.models.DFAContentModel

- All Implemented Interfaces:
    ContentModelValidator

      public class DFAContentModel
      extends java.lang.Object
      implements ContentModelValidator

  DFAContentModel is the derivative of ContentModel that does all of the non-trivial element content validation. This class does the conversion from the regular expression to the DFA that it then uses in its validation algorithm.

  Note: Upstream work insures that this class will never see a content model with PCDATA in it. Any model with PCDATA is 'mixed' and is handled via the MixedContentModel class since mixed models are very constrained in form and easily handled via a special case. This also makes implementation of this class much easier.

  Version:
    $Id: DFAContentModel.java 572057 2007-09-02 18:03:20Z mrglavas $

  # INTERNAL:

    Usage of this class is not supported. It may be altered or removed at any time.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DFAContentModel(CMNode syntaxTree, int leafCount, boolean mixed)` Constructs a DFA content model.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `validate(org.apache.xerces.xni.QName[] children, int offset, int length)` Check that the specified content is valid according to this content model.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DFAContentModel

          public DFAContentModel(CMNode syntaxTree,
                         int leafCount,
                         boolean mixed)

      Constructs a DFA content model.
      Parameters:
        `syntaxTree` - The syntax tree of the content model.
        `leafCount` - The number of leaves.
        `mixed` -

  - ### Method Detail

    - #### validate

          public int validate(org.apache.xerces.xni.QName[] children,
                     int offset,
                     int length)

      Check that the specified content is valid according to this content model. This method can also be called to do 'what if' testing of content models just to see if they would be valid.

      A value of -1 in the children array indicates a PCDATA node. All other indexes will be positive and represent child elements. The count can be zero, since some elements have the EMPTY content model and that must be confirmed.

      Specified by:
        `validate` in interface `ContentModelValidator`
      Parameters:
        `children` - The children of this element. Each integer is an index within the `StringPool` of the child element name. An index of -1 is used to indicate an occurrence of non-whitespace character data.
        `offset` - Offset into the array where the children starts.
        `length` - The number of entries in the `children` array.
      Returns:
        The value -1 if fully valid, else the 0 based index of the child that first failed. If the value returned is equal to the number of children, then the specified children are valid but additional content is required to reach a valid ending state.

Copyright © 1999-2022 The Apache Software Foundation. All Rights Reserved.